import chess.pgn

def open_num(filename):
	s = None
	s = open(filename, "rb").read()
	if s==None:
		return -1
	shift = 0
	result = 0
	for x in s:
		result |= ord(x)<<shift
		shift += 8
	return result

def save_num(filename, num):
	s = ""
	while num>0:
		s += (chr(num&255))
		num >>= 8
	open(filename, "wb").write(s)

def game_to_num(game):
	node = game
	l = []
	while len(node.variations)>0:
		n = 0
		for move in node.board().legal_moves:
			if move==node.variation(0).move:
				break;
			else:
				n += 1
		l.insert(0, [n, len(node.board().legal_moves) + 2])
		node = node.variation(0)
	n = len(node.board().legal_moves)
	if game.headers["Result"]=="1/2-1/2":
		l.insert(0, [n, n+2])
	else:
		l.insert(0, [n+1, n+2])
	result = 0
	for i in l:
		result = result*i[1] + i[0]
	return result

def num_to_game(num):
	game = chess.pgn.Game()
	node = game
	while True:
		legal_moves = []
		for move in node.board().legal_moves:
			legal_moves.append(move)
		n = len(legal_moves) + 2
		index = num%n
		if index==n-2:
			game.headers["Result"] = "1/2-1/2"
			return game
		elif index==n-1:
			if game.board().turn==chess.WHITE:
				game.headers["Result"] = "0-1"
			else:
				game.headers["Result"] = "1-0"
			return game
		else:
			num /= n
			node.add_main_variation(legal_moves[index])
			node = node.variation(0)

def compress(output_filename, input_filename):
	input_file = open(input_filename)
	game = chess.pgn.read_game(input_file)
	num = game_to_num(game)
	save_num(output_filename, num)

def decompress(output_filename, input_filename):
	num = open_num(input_filename)
	game = num_to_game(num)
	output_file = open(output_filename, "w")
	exporter = chess.pgn.FileExporter(output_file)
	game.export(exporter)

compress("171.pgnc", "171.pgn")
decompress("171.txt", "171.pgnc")

